=== meson_options.txt ===
option('tests', type: 'boolean', value: false, description: 'Build CLI11 tests')
