=== debian/changelog ===
cli11 (2.4.1+ds-2) unstable; urgency=medium

  * Bump autopkgtest to CMake 3.10
    (Closes: #1087855)

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Wed, 27 Nov 2024 10:39:59 +0000

cli11 (2.4.1+ds-1) unstable; urgency=medium

  * New upstream version 2.4.1+ds
  * Rediff patches. Drop catch patch merged upstream
  * Update d/copyright dates
  * Added patch for the pkgconfig installation path

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Mon, 26 Feb 2024 16:00:25 +0100
