## cli11 2.5.0%2Bds

=== debian/tests/control ===
Tests: build
Depends: @, cmake, build-essential
