=== debian/watch ===
Version: 5
Source: https://api.github.com/repos/CLIUtils/CLI11/git/matching-refs/tags/
Matching-Pattern: https://api.github.com/repos/[^/]+/[^/]+/git/refs/tags/@ANY_VERSION@
Download-Url-Mangle: s%(api.github.com/repos/[^/]+/[^/]+)/git/refs/%$1/tarball/refs/%g
Dversion-Mangle: auto
Filename-Mangle: s%.*/@ANY_VERSION@%@PACKAGE@-$1.tar.gz%
Repacksuffix: +ds
Searchmode: plain
